	
// ***************************************************************
// ********************* MAKE JSON HEAD *************************
// ***************************************************************
	String make_json_head() {	
		
		// *********** JSON KOPF ***********
		String json_konstrukt = "{\n";
		
		// Uhr ins format
		String tmmin = ":";
		String tmsec = ":";
		if (tm.tm_min < 9) tmmin = ":0";
		if (tm.tm_sec < 9) tmsec = ":0";
		
		// stamp
		json_konstrukt += "\"ESmart_zeitstamp\":";
		json_konstrukt += (String)time(&now);
		// zeit
		json_konstrukt += ",\n\"ESmart_zeit\":\"";
		json_konstrukt += zeit_akt;
		// datum
		json_konstrukt += "\",\n\"ESmart_datum\":\"";
		json_konstrukt += datum_akt;
	
		// stamp
		json_konstrukt += "\",\n\"ESmart_localIP\":\"";
		json_konstrukt += WiFi.localIP().toString();
		// stamp
		json_konstrukt += "\",\n\"ESmart_RSSI\":";
		json_konstrukt += (String)WiFi.RSSI();
		
		
		return json_konstrukt;
		
	} // ende JSON Kopf
	
// ***************************************************************
	void get_values() {
		if ( got_reg[0] ) {
			
			log_txt += "\nGet Reg 0: ";
			charge_mod.val = find_val_int(charge_mod);
			PvVolt.val = find_val_float(PvVolt);
			BatVolt.val = find_val_float(BatVolt);
			log_txt += "\nGet BatVolt.val: ";
			log_txt += (String)BatVolt.val;
			
			ChgCurr.val = find_val_float(ChgCurr);
			OutVolt.val = find_val_float(OutVolt);
			LoadVolt.val = find_val_float(LoadVolt);
			LoadCurr.val = find_val_float(LoadCurr);
			ChgPower.val = find_val_int(ChgPower);
			LoadPower.val = find_val_int(LoadPower);
			BatTemp.val = find_val_int(BatTemp);
			InnerTemp.val = find_val_int(InnerTemp);
			BatCap.val = find_val_int(BatCap);
			if (charge_mod.val == 0) ChgMode = "WAIT";
			if (charge_mod.val == 1) ChgMode = "MPPT";
			if (charge_mod.val == 2) ChgMode = "BULK";
			if (charge_mod.val == 3) ChgMode = "FLOAT";
			if (charge_mod.val == 4) ChgMode = "PRE";
			
			if (Load_max <  LoadPower.val ) Load_max = LoadPower.val;
			if (PV_max <  ChgPower.val ) PV_max = ChgPower.val;
			
			Fault.val  = find_val_int(Fault);
			SystemReminder.val  = find_val_int(SystemReminder);
			
			fault_txt = "";
			if (Fault.val & 1)		fault_txt += " * Battery voltage over";
			if (Fault.val & 2)		fault_txt += " * PV voltage over";	
			if (Fault.val & 4)		fault_txt += " * Charge current over";
			if (Fault.val & 8)		fault_txt += " * Dis-charge over";
			if (Fault.val & 16)		fault_txt += " * Battery temperature alarm";
			if (Fault.val & 32)		fault_txt += " * Internal temperature alarm";
			if (Fault.val & 64)		fault_txt += " * PV voltage low";
			if (Fault.val & 128)	fault_txt += " * Battery voltage low";	
			if (Fault.val & 256)	fault_txt += " * Trip zero protection trigger";
			if (Fault.val & 512)	fault_txt += " * In the control of manual switchgear";
			
			/*
1 bit Battery voltage over
2 bit PV voltage over
3 bit Charge current over
4 bit Dis-charge over
5 bit Battery temperature alarm
6 bit Internal temperature alarm
7 bit PV voltage low
8 bit Battery voltage low
9bit Trip zero protection trigger
10bit In the control of manual switchgear			
			*/
			
			got_reg[0] = 0;
		}
		
		if ( got_reg[1] ) {
			BatType.val = find_val_int(BatType);
			BatSysType.val = find_val_int(BatSysType);
			BulkVolt.val = find_val_float(BulkVolt);  // normal charge voltage (13.9V for lead-acid)
			FloatVolt.val = find_val_float(FloatVolt); // storage voltage after full charge (13.3V for lead-acid)
			MaxChgCurr.val = find_val_float(MaxChgCurr);
			MaxDisChgCurr.val = find_val_float(MaxDisChgCurr);
			EqualizeChgVolt.val = find_val_float(EqualizeChgVolt);
			EqualizeChgTime.val = find_val_int(EqualizeChgTime);
			LoadUseSel.val = find_val_int(LoadUseSel);
			got_reg[1] = 0;
		}
		
		if ( got_reg[2] ) {
			TodayEng.val = find_energy(TodayEng);
			MonthEng.val = find_energy(MonthEng);
			TotalEng.val = find_energy(TotalEng);
			LoadTodayEng.val = find_energy(LoadTodayEng);
			LoadMonthEng.val = find_energy(LoadMonthEng);
			LoadTotalEng.val = find_energy(LoadTotalEng);
			BacklightTime.val = find_val_int(BacklightTime);
			SwitchEnable.val = find_val_int(SwitchEnable);
			E_PV_Heute.val = find_energyWh(E_PV_Heute);
			E_Load_Heute.val = find_energyWh(E_Load_Heute);
			got_reg[2] = 0;
		}
				
		if ( got_reg[3] ) {
			PvVoltRatio.val = find_val_int(PvVoltRatio);
			PvVoltOffset.val = find_val_int(PvVoltOffset);
			BatVoltRatio.val = find_val_int(BatVoltRatio);
			BatVoltOffset.val = find_val_int(BatVoltOffset);
			ChgCurrRatio.val = find_val_int(ChgCurrRatio);
			ChgCurrOffset.val = find_val_int(ChgCurrOffset);
			LoadCurrRatio.val = find_val_int(LoadCurrRatio);
			LoadCurrOffset.val = find_val_int(LoadCurrOffset);
			LoadVoltRatio.val = find_val_int(LoadVoltRatio);
			LoadVoltOffset.val = find_val_int(LoadVoltOffset);
			OutVoltRatio.val = find_val_int(OutVoltRatio);
			OutVoltOffset.val = find_val_int(OutVoltOffset);
			got_reg[3] = 0;
		}
		
		if ( got_reg[4] ) {
			LoadModuleSelect1.val = find_val_int(LoadModuleSelect1);
			LoadModuleSelect2.val = find_val_int(LoadModuleSelect2);
			// 5100 Light control
			// 5116	Timer control
			// 5101 - 5115 time & light control
			if (LoadModuleSelect1.val == 5118) load_onoff = 0;
			if (LoadModuleSelect1.val == 5117) load_onoff = 1;
			got_reg[4] = 0;
		}

		if ( got_reg[7] ) {
			LoadOvp.val = find_val_float(LoadOvp);
			LoadUvp.val = find_val_float(LoadUvp);
			BatOvp.val = find_val_float(BatOvp);
			BatOvB.val = find_val_float(BatOvB);		
			BatUvp.val = find_val_float(BatUvp);
			BatUvB.val = find_val_float(BatUvB);
			got_reg[7] = 0;
		}	
	} // fnc refresh values

		//log_txt += "\nMake BatVolt.json: ";
		//log_txt += ",\n\t\""+key.name+" ("+key.unit+")\":"+(String)key.val;
		
// ***************************************************************
// ********************* format json *************************
// ***************************************************************
	String fjf( item_float key, byte tabu = 1, bool komma = 1 ) {
		String tmp = "";
		if (komma) tmp += ",";
		tmp += "\n";
		for (byte i=1; i<= tabu; i++) { tmp += "\t"; }
		
		return tmp + "\""+key.name+" ("+key.unit+")\":"+(String)key.val;
	} // fnc	
	
	String fji(item_int key, byte tabu = 1, bool komma = 1) {
		String tmp = "";
		if (komma) tmp += ",";
		tmp += "\n";
		for (byte i=1; i<= tabu; i++) { tmp += "\t"; }
		return tmp + "\""+key.name+" ("+key.unit+")\":"+(String)key.val;
	} // fnc
	
	String fjd(item_long key, byte tabu = 1, bool komma = 1) {
		String tmp = "";
		if (komma) tmp += ",";
		tmp += "\n";
		for (byte i=1; i<= tabu; i++) { tmp += "\t"; }
		return tmp + "\""+key.name+" ("+key.unit+")\":"+(String)key.val;
	} // fnc
	
	// ******* für DB ******************************
	String fjfdb(item_float key) {
		return ",\n\t\"ESmart_"+key.name+"\":"+(String)key.val;
	} // fnc	
	
	String fjidb(item_int key) {
		return ",\n\t\"ESmart_"+key.name+"\":"+(String)key.val;
	} // fnc
	
	String fjddb(item_long key) {
		return ",\n\t\"ESmart_"+key.name+"\":"+(String)key.val;
	} // fnc
	
	
	
// ***************************************************************
// ********************* MAKE AJAX *************************
// ***************************************************************
	void make_json_side() {	
		
		// *********** JSON KOPF ***********
		String json_konstrukt = make_json_head();
	
		json_konstrukt += ",\n\"Fault\":\"";
		json_konstrukt += String(Fault.val, BIN);		// 1000 bei set load 2A
		json_konstrukt += "\",\n\"Fault_txt\":\"";
		json_konstrukt += fault_txt;					// 1000 bei set load 2A
		json_konstrukt += "\",\n\"SystemReminder\":\"";
		json_konstrukt += String(SystemReminder.val, BIN);
		json_konstrukt += "\",\n\"LoadMod1\":";
		json_konstrukt += String(LoadModuleSelect1.val);
		
		json_konstrukt += fji(LoadModuleSelect1,0);		// LOAD onoff
		json_konstrukt += fji(LoadModuleSelect2,0);	
		json_konstrukt += fji(Fault,0);	
		
		json_konstrukt += ",\n\"side1\": {";
		json_konstrukt += "\n\t\"load_onoff\":"+(String)load_onoff;	
		json_konstrukt += fjf(MaxDisChgCurr);
		json_konstrukt += ",\n\t\"tab1\": {";
		
		json_konstrukt += fji(ChgPower,2,0);	// 2 Tab 0 Komma vorn
		json_konstrukt += fji(LoadPower,2);		//
		json_konstrukt += fjf(LoadVolt,2);
		json_konstrukt += fjf(LoadCurr,2);		//
		json_konstrukt += fji(BatCap,2);		//
		json_konstrukt += fjf(BatVolt,2);		//
		json_konstrukt += fjf(PvVolt,2);		//
		json_konstrukt += fjf(ChgCurr,2);		//
		json_konstrukt += fjd(E_PV_Heute,2);
		json_konstrukt += fjd(E_Load_Heute,2);
		//json_konstrukt += fjd(TodayEng,2);
		//json_konstrukt += fjd(LoadTodayEng,2);
		
		json_konstrukt += "\n\t}"; 		// ende Table
		json_konstrukt += ",\n\t\"ChgMode\":\""+ChgMode+"\"";
		json_konstrukt += ",\n\t\"PV_max\":"+(String)PV_max;
		json_konstrukt += ",\n\t\"Load_max\":"+(String)Load_max;
		json_konstrukt += "\n}";		// ende side1
		json_konstrukt += ",\n\"side2\": {";	// side2
		json_konstrukt += fjd(TodayEng,1,0);		// kein komma
		json_konstrukt += fjd(MonthEng);
		json_konstrukt += fjd(TotalEng);
		json_konstrukt += fjd(LoadTodayEng);
		json_konstrukt += fjd(LoadMonthEng);
		json_konstrukt += fjd(LoadTotalEng);
		
		json_konstrukt += fjd(E_PV_Heute);
		json_konstrukt += fjd(E_Load_Heute);

		json_konstrukt += "\n}";		// ende side2
		json_konstrukt += ",\n\"side3\": {";	// side3

		json_konstrukt += fji(BatType,1,0);
		json_konstrukt += fji(BatSysType);
		json_konstrukt += fji(BatTemp);
		
		json_konstrukt += ",\n\t\"laden\": {";	// laden
		json_konstrukt += fjf(BulkVolt,2,0);  // normal charge voltage (13.9V for lead-acid)
		json_konstrukt += fjf(FloatVolt,2); // storage voltage after full charge (13.3V for lead-acid)
		json_konstrukt += fjf(MaxChgCurr,2);
		json_konstrukt += fjf(EqualizeChgVolt,2);
		json_konstrukt += fji(EqualizeChgTime,2);
		json_konstrukt += fji(LoadUseSel,2);
		json_konstrukt += "\n\t}"; 		// ende laden
		json_konstrukt += ",\n\t\"protect\": {";	// protect
		json_konstrukt += fjf(LoadOvp,2,0); // Load overvoltage protection
		json_konstrukt += fjf(LoadUvp,2); // Load low voltage protection 
		json_konstrukt += fjf(BatOvp,2); // Overvoltage protection of battery
		json_konstrukt += fjf(BatOvB,2); // Battery overvoltage recovery point
		json_konstrukt += fjf(BatUvp,2); // Battery low voltage protection
		json_konstrukt += fjf(BatUvB,2); // Battery low voltage recovery
		json_konstrukt += "\n\t}"; 		// ende protect
		
		json_konstrukt += "\n}";		// ende side2
		
		json_konstrukt += ",\n\"side4\": {";	// side3

		json_konstrukt += fji(PvVoltRatio,1,0); 
		json_konstrukt += fji(PvVoltOffset);
		json_konstrukt += fji(BatVoltRatio);
		json_konstrukt += fji(BatVoltOffset);
		json_konstrukt += fji(ChgCurrRatio);
		json_konstrukt += fji(ChgCurrOffset);
		json_konstrukt += fji(LoadCurrRatio);
		json_konstrukt += fji(LoadCurrOffset);
		json_konstrukt += fji(LoadVoltRatio);
		json_konstrukt += fji(LoadVoltOffset);
		json_konstrukt += fji(OutVoltRatio);
		json_konstrukt += fji(OutVoltOffset);
		
		json_konstrukt += "\n}";		// ende side4
		
		
		json_konstrukt += "\n}"; // ende json
	
		ajax = json_konstrukt;
		log_txt += "\najax: ";
		log_txt += ajax;
		
	} // fnc make side

// ***************************************************************
// ********************* MAKE JSON BAT *************************
// ***************************************************************
	void make_json_bat() {		
		
		String json_konstrukt = make_json_head();
		
		json_konstrukt += fjf(BatVolt);	
		json_konstrukt += fjf(MaxDisChgCurr);
		json_konstrukt += fji(BatTemp);
		json_konstrukt += fji(BatType);
		json_konstrukt += fji(BatSysType);
		json_konstrukt += fjf(BulkVolt);  // normal charge voltage (13.9V for lead-acid)
		json_konstrukt += fjf(FloatVolt); // storage voltage after full charge (13.3V for lead-acid)
		json_konstrukt += fjf(MaxChgCurr);
		json_konstrukt += fjf(MaxDisChgCurr);  // WARNING: does not limit current, only sets fault flag
		json_konstrukt += fjf(EqualizeChgVolt);
		json_konstrukt += fji(EqualizeChgTime);
		json_konstrukt += fji(LoadUseSel);
		json_konstrukt += fjf(LoadOvp); // Load overvoltage protection
		json_konstrukt += fjf(LoadUvp); // Load low voltage protection 
		json_konstrukt += fjf(BatOvp); // Overvoltage protection of battery
		json_konstrukt += fjf(BatOvB); // Battery overvoltage recovery point
		json_konstrukt += fjf(BatUvp); // Battery low voltage protection
		json_konstrukt += fjf(BatUvB); // Battery low voltage recovery
		
		json_konstrukt += "\n}";
		json_bat = json_konstrukt;
	
	} // fnc bat

// ***************************************************************
// ********************* MAKE JSON ENERGY *************************
// ***************************************************************
	void make_json_energy() {		

		String json_konstrukt = make_json_head();
		json_konstrukt += fjd(TodayEng);
		json_konstrukt += fjd(MonthEng);
		json_konstrukt += fjd(TotalEng);
		json_konstrukt += fjd(LoadTodayEng);
		json_konstrukt += fjd(LoadMonthEng);
		json_konstrukt += fjd(LoadTotalEng);
		
		json_konstrukt += fjd(E_PV_Heute);
		json_konstrukt += fjd(E_Load_Heute);
		
		json_konstrukt += "\n}";
		json_energy = json_konstrukt;
	} // fnc energy

// ***************************************************************
// ********************* MAKE JSON BAT *************************
// ***************************************************************
	void make_json_DB() {		
		
		String json_konstrukt = make_json_head();
		
		json_konstrukt += ",\n\t\"ESmart_ChgMode\":\""+ChgMode+"\"";
		json_konstrukt += ",\n\t\"ESmart_PV_max\":"+(String)PV_max;
		json_konstrukt += ",\n\t\"ESmart_Load_max\":"+(String)Load_max;
		json_konstrukt += fjfdb(PvVolt);
		json_konstrukt += fjddb(TodayEng);
		json_konstrukt += fjddb(MonthEng);
		json_konstrukt += fjddb(TotalEng);
		json_konstrukt += fjfdb(BatVolt);	
		json_konstrukt += ",\n\t\"ESmart_load_onoff\":"+(String)load_onoff;
		json_konstrukt += fjfdb(MaxDisChgCurr);	
		json_konstrukt += fjfdb(LoadVolt);
		json_konstrukt += fjidb(BatCap);
		json_konstrukt += fjfdb(ChgCurr);
		json_konstrukt += fjidb(ChgPower);
		json_konstrukt += fjfdb(LoadCurr);
		json_konstrukt += fjidb(LoadPower);
		json_konstrukt += fjddb(E_PV_Heute);
		json_konstrukt += fjddb(E_Load_Heute);
		json_konstrukt += fjddb(LoadTodayEng);
		json_konstrukt += fjddb(LoadMonthEng);
		json_konstrukt += fjddb(LoadTotalEng);
		json_konstrukt += fjidb(BatTemp);
		json_konstrukt += fjidb(InnerTemp);
		
		json_konstrukt += "\n}";
		json_stat = json_konstrukt;
	} // fnc json
		

		


			/*	
		data bytes:
		170,1,0,3,7,16, ** 0,0,64,96, ** 160,0,105,0,160,0,150,0,115,0,110,0, ** 123,
		END								10 - 21

		
		Data item ID: 0x07	Attributes： Read and write
			Bytes Content Offset Unit Remarks
			2 Uint16 wFlag; 00 00 Flag
			2 Uint16 wLoadOvp; 01 00 0.1V Load overvoltage protection
			2 Uint16 wLoadUvp; 02 00 0.1V Load low voltage protection
			2 Uint16 wBatOvp; 03 00 0.1V Overvoltage protection of battery
			2 Uint16 wBatOvB; 04 00 0.1V Battery overvoltage recovery point
			2 Uint16 wBatUvp; 05 00 0.1V Battery low voltage protection
			2 Uint16 wBatUvB; 06 00 0.1V Battery low voltage recovery
			2 Uint16 ChkSum;
		*/

		/*		
		
		data bytes:
		170,1,0,3,0,28,0,0,0,0,1,0,242,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,23,0,30,0,0,0,245,
		END
		
		2 Uint16 wChgMode; 00 00 Charge Mode（0~4）
		2 Uint16 wPvVolt; 01 00 0.1V PV input Voltage
		2 Uint16 wBatVolt; 02 00 0.1V Bat Voltage
		2 Uint16 wChgCurr; 03 00 0.1A Charging Current
		2 Uint16 wOutVolt; 04 00 0.1V /(Internal use)
		2 Uint16 wLoadVolt; 05 00 0.1V Load Voltage
		2 Uint16 wLoadCurr; 06 00 0.1A Load Current
		2 Uint16 wChgPower; 07 00 1W Charging Power
		2 Uint16 wLoadPower; 08 00 1W Load Power
		2 int16 wBatTemp; 09 00 1℃ Battrey temperature
		2 int16 wInnerTemp; 0A 00 1℃ Internal temperature
		2 Uint16 wBatCap; 0B 00 1% Battery level
		4 Uint32s dwCO2 0C 00 0.1kg CO2 emission reduction
		2 Uint16 wFault;0E 00Table 9-1 breakdown information details
		2 Uint16 wSystemReminder； 0F 00 Table 9-2 system hints details
		*/
		

		/*
		
		data bytes:
		170,1,0,3,4,24,0,0,64,96,254,19,80,20,44,1,244,1,10,0,10,0,18,0,30,0,21,0,30,0,136,
		END
		
		// power
		POWER: 170,1,0,
		3,2,  46, anzahl x2E			i = 5
		0,0,66,96, x42 x60 24642 ???? 	i = 6 - 9
		0000*0,0, offset				i = 10 - 11
		0100*200,0, xc8 RunTime min > 3h  i = 12 - 13
		0300*1,0, startCnt				i = 14 - 15
		0400*22,0, x16 LastFaultInfo	i = 16 - 17
		0500*3,0, wFaultCnt				i = 18 - 19
		0600*0,0,0,0,  PVTodayEng wh	20 - 23 pvheute 		****
		0800*0,0,0,0, data_t PVwTodayEngDate 24 - 27 pvdatd
		0a00*0,0,0,0, PVMonthEng MSw LSw wh  28 - 31 pvmonat	****
		0c00 0,0,0,0, data_t PVMothEngDate	32 - 35 pvdatm
		0e00*0,0,89,23,  -- x59 x17  5977 PVTotalEng wh 36 - 39 pvtotal		****
		1000*0,0,0,0, LoadTodayEng wh		40 - 43 loadheute		****
		1200*0,0,0,0, LoadMonthEng wh		44 - 47 loadmonat		****
		1400*0,0,83,25, -- x53 x19 6483 LoadTotalEng wh 48 - 51 loadtotal		****
		194 check 52
		*/
