
/*				
        
                                ______________________
                                |       |___|        |
                  VCC RS485 3v3 |                    | 5v  
                            15  | D8   ESP           | GND  
    (auf TX!!) SSerial  TX  13  | D7   8266       D4 | 2 
							12  | D6              D3 | 0 
    (auf RX!!) SSerial  RX  14  | D5              D2 | 4 
							16  | D0              D1 | 5 
                         Analog | A0              RX | 3 USB
                          Reset | RST             TX | 1 USB
                                |____________________|


*/

		//							    /|
		//				S - apparent   / |
		//				    Power	  /	 | Q - reactive
		//				      		 /	 | Power
		//					      	/____|
		//						
		//						    P - real
		//						    Power
		


// ***************************************************************
// ********************* COMANDS *********************************
// ***************************************************************

	// 	170,1,0,1,0,3,0,0,34,47  -- 34Byte
	// 170,1,0,1,0,3,0,0,32,49	 -- 32Byte
	
	const uint8_t cmd_get[][10] = {
	// 					Com	  Reg   len   off x0000 *** expect len minus offset 2Byte !!
    // { 0xaa, 0x01, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x1a, 0x37 }, // 0 - GET - run state 	exp:26 bytes
	{ 0xaa, 0x01, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x20, 0x31 }, // 0 - GET - run state 	exp:32 bytes
	{ 0xaa, 0x01, 0x00, 0x01, 0x01, 0x03, 0x00, 0x00, 0x14, 0x3c }, // 1 - GET - battery	exp:18 bytes 
	{ 0xaa, 0x01, 0x00, 0x01, 0x02, 0x03, 0x00, 0x00, 0x2c, 0x23 }, // 2 - GET - energie	exp:44 bytes
	{ 0xaa, 0x01, 0x00, 0x01, 0x03, 0x03, 0x00, 0x00, 0x1a, 0x34 }, // 3 - GET - korrektur
	{ 0xaa, 0x01, 0x00, 0x01, 0x04, 0x03, 0x00, 0x00, 0x16, 0x37 }, // 4 - GET - ONOFF PV LOAD
	{ 0xaa, 0x01, 0x00, 0x01, 0x07, 0x03, 0x00, 0x00, 0x0e, 0x3c }  // 7 - GET - Protection	exp:14 bytes
	};
	
	const uint8_t cmd_set[][11] = {
	// LOAD ONOFF
	// 					Com	  Reg   len   data ..
    { 0xaa, 0x01, 0x00, 0x02, 0x04, 0x04, 0x01, 0x00, 0xfe, 0x13, 0x39 }, // 0 - SET - Load off 
    { 0xaa, 0x01, 0x00, 0x02, 0x04, 0x04, 0x01, 0x00, 0xfd, 0x13, 0x3a }, // 1 - SET - Load on

	// PV ONOFF
	{ 0xaa, 0x01, 0x00, 0x02, 0x06, 0x04, 0x01, 0x00, 0x01, 0x00, 0x47 }, // 5 - SET - charge start
	{ 0xaa, 0x01, 0x00, 0x02, 0x06, 0x04, 0x01, 0x00, 0x02, 0x00, 0x46 }, // 6 - SET - charge stop
	
	//5118 - 254,19 - 0xfe 0x13 off 
	//5117 - 253,19 - 0xfd 0x13 on

	{ 0xaa, 0x01, 0x00, 0x02, 0x07, 0x04, 0x05, 0x00, 0x73, 0x00, 0xd0 }, // 8 - SET - set protec
	
	// SET LOAD 1A - 8A
	// 					Com	  Reg   len   data ..	
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x0a, 0x00, 0x3e }, // 10 - SET - 10 # LOAD curr x1A
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x14, 0x00, 0x34 }, // 11 - SET - 20 # Off: 06 00
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x1e, 0x00, 0x2a }, // 12 - SET - 30
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x28, 0x00, 0x20 }, // 13 - SET - 4A # 0.1A
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x32, 0x00, 0x16 }, // 14 - SET - 
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x3c, 0x00, 0x0c }, // 15 - SET - 
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x46, 0x00, 0x02 }, // 16 - SET - 
	{ 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x50, 0x00, 0xf8 }  // 17 - SET - 8A ~400W
	
	};
	
	
	/*
	0-Load off 
	1-Load on 
	2- run state
	3- bat 
	4- energie
	5 - charg start
	6 - charg stop
	7 - read load onoff
	8 - set protec // intern Parameter read
	9 - Protection Parameter read
	10-17 LOAD curr x1A
	*/
	// Load auf 1A
	// 0xaa, 0x01, 0x00, 0x02, 0x01, 0x04, 0x06, 0x00, 0x0a, 0x00, 0x6c
	//                   set    reg      anz           amp        0,1A        0-194 = 0x6c
	

	byte regs[11][60];		// Register *****************
	/*  0 ChgSts,
        1 BatParam, 170,1,0,3,1,22,0,0,66,96,2,0,4,0,144,0,137,0,88,2,20,0,146,0,30,0,0,0,92
        2 Energy,
        4 ratio,
        5 LoadParam,
        6 RemoteControl,
        7 Protec,
        8 Information,
        9 TmpParam,
        10 statistic */
	
	bool got_reg[11] = {0,0,0,0,0,0,0,0,0,0,0};
	
	const String bez[] = {"Load off","Load on","statrun","Bat read","power read","charg start","charg stop","read load","set protec","read Protection"};
	const uint8_t lenarr[] = {11,11,10,10,10,11,11,10,11,10,   11,11,11,11,11,11,11,11};
	uint8_t cmd_num = 2;


//  ---------------------------------------

	// SERVER
	String server = "http://192.168.123.2/libs_intern_wan/webseiten"; // Bibilotheken HTML
	String url_get = "http://192.168.123.1/datafiles/esp_need_data.php?"; // ON OFF PV sunrise / down

	// var wifi
	const char *ssid = "";					// yours #####################################
	const char *password = "";				// yours #####################################
	const byte ip_add[4] = { 192, 168, 123, 8 };
	const byte gate_add[4] = { 192, 168, 123, 254 };
	const byte sub_add[4] = { 255, 255, 0, 0 };
	const char *DNS = "esp-esmart3";
	const char *IP_me = "http://192.168.123.8/";

	// webserver
	ESP8266WebServer server_intern ( 80 );
	
	// ************* ZEITSERVER ***************** NTP 
	constexpr uint32_t SYNC_INTERVAL = 12;                           // NTP Sync Interval in Stunden einstellen
	bool timeSync;

	//#define MY_NTP_SERVER "192.168.123.254"            // Fritzbox klappt :-)
	const char* const PROGMEM NTP_SERVER[] = {"192.168.123.254", "de.pool.ntp.org"};
	#define MY_TZ "CET-1CEST,M3.5.0/02,M10.5.0/03" 
	/* Globals zeit*/
	time_t now;                         // this is the epoch
	tm tm;                              // the structure tm holds time information in a more convient way


	// SSerial

	#define TX 13
	#define RX 14
	SoftwareSerial swSer(RX, TX); //, false, 256);

	// Zeiten
	const byte intervall_json = 20, intervall_send = 1, intervall_ajax = 2; // in sec
	uint32_t T1_alt, T2_alt, T3_alt;
	
	// JSONS
	String json_txt = "", json_energy = "", json_stat = "", json_tmp = "", ajax = "", log_txt = "";
	String respose_bytes = "nix", test_out = "", json_bat = "";
	
	// VAL
	uint32_t sunrise = 0, sunset = 0; // sonnen auf untergang
	bool daylight = false;
	uint16_t sol_rad = 0;
	byte get_check_arr = 0;
	bool wifi_reset_en = false;
	
	String zeit_akt = "", datum_akt = "";
	uint8_t alt_mon = 0, alt_tag = 0;
	bool check_suntime =false,check_anfang_werte=false;

	byte loop_i = 0; // läuft mit loop  register

	