
	struct item_float {
		String 	name;
		byte	reg;
		byte	add;
		float	fkt;
		bool 	sign;
		char	unit = '_';
		float	val = 0;
	}; 
	
	struct item_int {
		String 	name;	
		byte	reg;
		byte	add;
		float	fkt;
		bool 	sign;
		char	unit[4] = "";
		int		val = 0;
	}; 
	
	struct item_long {
		String 	name;	
		byte	reg;
		byte	add;
		float	fkt;
		bool 	sign;
		char	unit[4] = "kWh";
		uint32_t	val = 0;
	}; 
	
// **************************************************************
// ********************* get value *************************
// ***************************************************************	
	// 2 Byte
	float find_val_float(item_float key) {
		byte i = key.add;
		log_txt += "\nGet reg add: ";
		log_txt += (String)key.add;
		int val;
		uint16_t uval;
		if (key.sign) {
			val = (regs[key.reg][(i+1)]<<8) + regs[key.reg][i];
			log_txt += "\nGet add0: ";
			log_txt += (String)regs[key.reg][i];
			return val * key.fkt;
		}else{
			uval = (regs[key.reg][(i+1)]<<8) + regs[key.reg][i];	
			return uval * key.fkt;
		}
	}	
	
	// 2 Byte
	int find_val_int(item_int key) {
		byte i = key.add;
		return  (regs[key.reg][(i+1)]<<8) + regs[key.reg][i];
	}	

	// 4 BYTE
	float find_energy(item_long key) {
		byte i = key.add;
		uint32_t val = ( (regs[key.reg][(i+1)]<<24) & 0xFF000000 ) | ( (regs[key.reg][i]<<16) & 0xFF0000 ) | ( (regs[key.reg][(i+3)]<<8) & 0xFF00 ) | ( regs[key.reg][(i+2)] & 0xFF ); // 28 - 31 PVheute 
		return val / 1000;
	}		

	// 4 BYTE
	uint32_t find_energyWh(item_long key) {
		byte i = key.add;
		uint32_t val = ( (regs[key.reg][(i+1)]<<24) & 0xFF000000 ) | ( (regs[key.reg][i]<<16) & 0xFF0000 ) | ( (regs[key.reg][(i+3)]<<8) & 0xFF00 ) | ( regs[key.reg][(i+2)] & 0xFF ); // 28 - 31 PVheute 
		return val;
	}		

	uint16_t  Load_max = 0, PV_max = 0;
	String fault_txt = "";

	// Reg 0
	String	ChgMode = "wait";
	item_int 	charge_mod = {"charge_mod",0,8,1,0}; // uint 2B
	item_float 	PvVolt = {"PvVolt",0,10,0.1,0,'V'}; // float 2B
	item_float 	BatVolt = {"BatVolt",0,12,0.1,0,'V'}; // float 2B
	item_float 	ChgCurr = {"ChgCurr",0,14,0.1,0,'A'}; // float 2B
	item_float 	OutVolt = {"OutVolt",0,16,0.1,0,'V'}; // float 2B
	item_float 	LoadVolt = {"LoadVolt",0,18,0.1,0,'V'}; // float 2B
	item_float 	LoadCurr = {"LoadCurr",0,20,0.1,0,'A'}; // float 2B
	item_int 	ChgPower = {"ChgPower",0,22,1,0,"W"}; // uint 2B
	item_int 	LoadPower = {"LoadPower",0,24,1,0,"W"}; // uint 2B
	item_int 	BatTemp = {"BatTemp",0,26,1,1,"'C"}; // float 2B
	item_int 	InnerTemp = {"InnerTemp",0,28,1,1,"'C"}; // float 2B
	item_int 	BatCap = {"BatCap",0,30,1,0,"%"}; // uint 2B
	item_long 	CO2 = {"CO2",0,32,0.1,0,"kg"}; // 4B
	item_int 	Fault = {"Fault",0,36,1,0,"_"}; // uint 2B
	item_int 	SystemReminder = {"SystemReminder",0,38,1,0,"_"}; // uint 2B
	
	// Reg 1			Bez, Reg, Add0, faktor, sign, unit, value
	item_int 	BatType = {"BatType",1,10,1,0}; // float 2B
	item_int 	BatSysType = {"BatSysType",1,12,1,0}; // float 2B
	item_float 	BulkVolt = {"BulkVolt",1,14,0.1,0,'V'}; // float 2B
	item_float 	FloatVolt = {"FloatVolt",1,16,0.1,0,'V'}; // float 2B
	item_float 	MaxChgCurr = {"MaxChgCurr",1,18,0.1,0,'A'}; // float 2B
	item_float 	MaxDisChgCurr = {"MaxDisChgCurr",1,20,0.1,0,'A'}; // float 2B
	item_float 	EqualizeChgVolt = {"EqualizeChgVolt",1,22,0.1,0,'V'};
	item_int 	EqualizeChgTime = {"EqualizeChgTime",1,24,1,0,"min"};
	item_int 	LoadUseSel = {"LoadUseSel",1,26,1,0,"%"};
	
	// reg 2
	item_long 	TodayEng = {"TodayEng",2,20,1,0,"kWh"};
	item_long 	MonthEng = {"MonthEng",2,28,1,0,"kWh"};
	item_long 	TotalEng = {"TotalEng",2,36,1,0,"kWh"};
	item_long 	LoadTodayEng = {"LoadTodayEng",2,40,1,0,"kWh"};
	item_long 	LoadMonthEng = {"LoadMonthEng",2,44,1,0,"kWh"};
	item_long 	LoadTotalEng = {"LoadTotalEng",2,48,1,0,"kWh"};
	item_int  	BacklightTime = {"BacklightTime",2,52,1,0,"sec"};
	item_int 	SwitchEnable = {"SwitchEnable",2,54,1,0};
	
	item_long 	E_PV_Heute = {"E_PV_Heute",2,20,1,0,"Wh"};
	item_long 	E_Load_Heute = {"E_Load_Heute",2,40,1,0,"Wh"};
	
	
	// Reg 3
	item_int PvVoltRatio = {"PvVoltRatio",3,10,0.1,0,"dig"}; 
	item_int PvVoltOffset = {"PvVoltOffset",3,12,0.1,0,"dig"}; 
	item_int BatVoltRatio = {"BatVoltRatio",3,14,0.1,0,"dig"}; 
	item_int BatVoltOffset = {"BatVoltOffset",3,16,0.1,0,"dig"}; 
	item_int ChgCurrRatio = {"ChgCurrRatio",3,18,0.1,0,"dig"}; 
	item_int ChgCurrOffset = {"ChgCurrOffset",3,20,0.1,0,"dig"}; 
	item_int LoadCurrRatio = {"LoadCurrRatio",3,22,0.1,0,"dig"};
	item_int LoadCurrOffset = {"LoadCurrOffset",3,24,0.1,0,"dig"};
	item_int LoadVoltRatio = {"LoadVoltRatio",3,26,0.1,0,"dig"};
	item_int LoadVoltOffset = {"LoadVoltOffset",3,28,0.1,0,"dig"};
	item_int OutVoltRatio = {"OutVoltRatio",3,30,0.1,0,"dig"};
	item_int OutVoltOffset = {"OutVoltOffset",3,32,0.1,0,"dig"};
		
	// reg 4
	bool		load_onoff = 0;
	item_int 	LoadModuleSelect1 = {"LoadModuleSelect1",4,10,1,0}; // uint 2B
	item_int 	LoadModuleSelect2 = {"LoadModuleSelect2",4,12,1,0}; // uint 2B
	

	// reg 7
	item_float 	LoadOvp = {"LoadOvp",7,10,0.1,0,'V'}; // float 2B
	item_float 	LoadUvp = {"LoadUvp",7,12,0.1,0,'V'}; // float 2B
	item_float 	BatOvp = {"BatOvp",7,14,0.1,0,'V'}; // float 2B
	item_float 	BatOvB = {"BatOvB",7,16,0.1,0,'V'}; // float 2B
	item_float 	BatUvp = {"BatUvp",7,18,0.1,0,'V'}; // float 2B
	item_float 	BatUvB = {"BatUvB",7,20,0.1,0,'V'}; // float 2B

/*
1 bit Battery voltage over
2 bit PV voltage over
3 bit Charge current over
4 bit Dis-charge over
5 bit Battery temperature alarm
6 bit Internal temperature alarm
7 bit PV voltage low
8 bit Battery voltage low
9bit Trip zero protection trigger
10bit In the control of manual switchgear
*/